
// The following ifdef block is the standard way of creating macros which make exporting
// from a DLL simpler. All files within this DLL are compiled with the CGD3D_AB_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see
// CGD3D_AB_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef CGD3D_AB_EXPORTS
#define CGD3D_AB_API __declspec(dllexport)
#else
#define CGD3D_AB_API extern
#endif

#ifdef CGD3D_AB_EXPORTS
#include "cg\cgD3D.h"
#define CGD3D_API __cdecl
#else
#include "cgD3D.h"
#define CGD3D_API __cdecl
#endif

#ifdef __cplusplus
extern "C" {
#endif

CGD3D_AB_API const char * CGD3D_API cgProgramContainer_GetVertexDeclaration(void *self);
CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetShaderConstantD3DXMATRIX(void *self, cgBindIter * iter, const D3DXMATRIX *m, int nArrayElements = 0, int ArrayOffset = 0);

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetShaderConstant(void *self, cgBindIter * iter, void * data, int nArrayElements = 0, int ArrayOffset = 0);

CGD3D_AB_API int CGD3D_API cgProgramContainer_GetTexturePosition(void *self, cgBindIter * BindIter);
CGD3D_AB_API int CGD3D_API cgProgramContainer_GetTexturePositionB(void *self, const char * name);

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTexture(void *self, const char * name, LPDIRECT3DBASETEXTURE8 pTexture);
CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTextureB(void *self, cgBindIter * BindIter, LPDIRECT3DBASETEXTURE8 pTexture);
CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTextureStageState(void *self, cgBindIter * BindIter, D3DTEXTURESTAGESTATETYPE Type,DWORD Value);
CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTextureWrapMode(void *self, cgBindIter * BindIter, DWORD WrapCoords);

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetShaderActive(void *self);

CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetVertexBindByName(void *self, const char *vertex_attr_name);
CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetTextureBindByName(void *self, const char *texture_name);
CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetParameterBindByName(void *self, const char *parameter_name);

CGD3D_AB_API void CGD3D_API cgProgramContainer_FreeBindIter(void *self, cgBindIter *c);

CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetBindByFullName(void *self, const char *parameter_name);
CGD3D_AB_API const char *CGD3D_API cgProgramContainer_GetProgramName(void *self);
CGD3D_AB_API const char * CGD3D_API cgProgramContainer_GetProgramObjectCode(void *self);
CGD3D_AB_API cgProfileType CGD3D_API cgProgramContainer_GetProgramProfile(void *self); // { return m_ProfileType;}
CGD3D_AB_API DWORD CGD3D_API cgProgramContainer_GetShaderHandle(void *self); // {return m_dwShaderHandle;}

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

CGD3D_AB_API cgDirect3D * CGD3D_API cgDirect3D_Create();
CGD3D_AB_API void CGD3D_API cgDirect3D_Destroy(cgDirect3D * cg);

CGD3D_AB_API void CGD3D_API cgDirect3D_AddFilePath(void *self, const char * dirpath);
CGD3D_AB_API void CGD3D_API cgDirect3D_NotePad(void *self, const char * title, const char * listing );
CGD3D_AB_API cgContextContainer * CGD3D_API cgDirect3D_CreateContextContainer(void *self, LPDIRECT3DDEVICE8 pd3dDevice, DWORD * outIndex = 0);



//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

CGD3D_AB_API const char *CGD3D_API cgContextContainer_GetLastListing(void *self);
CGD3D_AB_API cgProgramContainer * CGD3D_API cgContextContainer_LoadCGProgramFromFile(void *self,
        const char * filename,           // filename of the Cg program
        const char * title,               // title of the program
        cgProfileType type,       // profile of the program
        cgVertexDefinition * va = 0, // optionally, set streams or allow different vetex definitions
        DWORD * outIndex = 0,
        const char * entry = 0);
CGD3D_AB_API cgProgramContainer *  CGD3D_API cgContextContainer_LoadCGProgramFromMemory(void *self,
        const char * memory,          // memory location that contain the cg program
        const char * title,            // name of the program
        cgProfileType type,    // profile of the program
        cgVertexDefinition * va = 0,   // optionally, set the streams for each vertex entry
        DWORD * outIndex = 0,
        const char * entry = 0);
CGD3D_AB_API cgProgramContainer * CGD3D_API cgContextContainer_GetProgramIterator(void *self, DWORD index);
CGD3D_AB_API cgProgramIter *CGD3D_API cgContextContainer_GetNextProgram(void *self, cgProgramIter *iter);
CGD3D_AB_API cgProgramIter *CGD3D_API cgContextContainer_ProgramByName(void *self, const char *name);
CGD3D_AB_API DWORD CGD3D_API cgContextContainer_GetShaderHandle(void *self, cgProfileType type);
CGD3D_AB_API void CGD3D_API cgContextContainer_Destroy(cgContextContainer * c);


//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/*
CGD3D_AB_API HRESULT cgProgramManager_Free(void *self);

CGD3D_AB_API cgProgramContainer * cgProgramManager_CreateProgramContainer(void *self, LPDIRECT3DDEVICE8 pDev,
        cgProgramIter * ProgramIter,
        DWORD Usage,
        cgProfileType ProfileType,
        DWORD * outIndex );
CGD3D_AB_API DWORD	cgProgramManager_GetShaderHandle( void *self, DWORD Index );
CGD3D_AB_API DWORD	cgProgramManager_GetShaderHandle( void *self, cgProfileType ProfileType );
CGD3D_AB_API cgProgramContainer * cgProgramManager_GetProgramIterator(void *self, DWORD index);
*/

#ifdef __cplusplus
}
#endif

